package xyz.thastertyn.Types;

import java.util.ArrayList;

public class Predmet {
	
	private ArrayList<Znamka> marks = new ArrayList<>();
	private String subjectName = "";
	private boolean isFinal = false;

	private FinalMark finalMark = FinalMark.UNKNOWN;

	public Predmet(String subjectName)
	{
		this.subjectName = subjectName;
	}

	public Predmet(String subjectName, FinalMark finalMark)
	{
		this.subjectName = subjectName;
		this.finalMark = finalMark;
		isFinal = true;
	}

	public void addZnamka(Znamka newMark)
	{
		marks.add(newMark);
	}

	public void calculateFinalMark()
	{
		int total = marks
		.stream()
		.mapToInt((z) -> z.getZnamka() * z.getVaha())
		.sum();

		int weight = marks
			.stream()
			.mapToInt((z) -> z.getVaha())
			.sum();

		double finalMark = ((double) total / weight);

		this.finalMark = new FinalMark(finalMark);
	}

	public FinalMark getFinalMark()
	{
		return finalMark;
	}

	public boolean isFinal()
	{
		return isFinal;
	}

	public String getSubjectName()
	{
		return subjectName;
	}

	public ArrayList<Znamka> getMarks()
	{
		return marks;
	}
}

